package com.hzs.sale.wares;

import com.hzs.common.core.domain.R;
import com.hzs.common.domain.sale.ext.BdWaresInfoExt;
import com.hzs.sale.wares.dto.WaresDTO;

import java.util.Date;
import java.util.List;

/**
 * 商品对外提供接口
 */
public interface IWaresServiceApi {

    /**
     * 校验标签是否使用
     *
     * @param pkLabel 标签主键
     * @return
     */
    R<Boolean> checkLabelisUse(Integer pkLabel);

    /**
     * 修改自动上下架状态（自动上架）
     *
     * @param currentTime 当前时间
     */
    void updateByAutoStartAndAutoStart(Date currentTime);

    /**
     * 定时商品自动下架
     *
     * @param currentTime
     */
    void updateByAutoStartAndAutoEnd(Date currentTime);

    /**
     * 根据专区查询商品的ID信息
     *
     * @param specialArea 专区
     * @param pkCountry   国家ID
     * @return
     */
    R<BdWaresInfoExt> selectWaresBySpecial(Integer specialArea, Integer pkCountry);

    /**
     * 查询全部商品
     *
     * @param pkCountry
     * @return
     */
    R<List<WaresDTO>> findAll(Integer pkCountry);
}
